mod Ex04a logic: 'cl'

incl Mtex

incl Mtexg

loc rem 
  \para \bf  4. CVICENIE Z PREDMETU 1-AIN-470 SPECIFIKACIA A VERIFIKACIA 
  PROGRAMOV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.19 
  \para* \it  Datum:  \end streda 5.3.2008 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-470-svp/0708ls/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane explicitnym 
  definiciam a primitivnej rekurzii. Zadanie sa sklada z tychto suborov: 
  \items 
   \item \para Subory \it  mtex*.cl  \end obsahuju makra pre CL-TeX. 
   \item \para Subory \it  ex*.cl  \end obsahuju ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  [CL] Remark.  \end The module \it  Mlogicq  \end in the file \it  
  mlogicq.cl  \end contains the syntax of quantifier tableau rules. The module 
  \it  Mlogicd  \end in the file \it  mlogicd.cl  \end contains the syntax of 
  derived tableau rules. 

rem 
  \para \bf  Chapter. Numeric Programs.  \end 

rem 
  \para \bf  Section. Explicit Definitions.  \end 

rem 
  \para \bf  [CL] Monadic case analysis.  \end Syntax: 
  \eq* 
    'case N ; <term>'
  \end
  \para Example(s): 
  \items 
   \item \para \ft Tex_f1_g_x_case Tex_f2_g_x_sc(N,Tex0_tau) \end 
         \eq* 
           Tex_f3_g_x_nrule(Tex_f0_g_x_nothing,
                            Tex_f2_g_x_branch(Tex_f1_g_x_assum Tex_f2_g_eq(Tex0_tau,
                                                                           0),
                                              Tex_f1_g_x_assum Tex_f2_g_eq(Tex0_tau,
                                                                           x+1)),
                            Tex_f0_g_x_nothing)
         \end
         \para where \ft x \end is a new variable \it  (eigen-variable)  \end. 
  \end

rem 
  \para \bf  [CL] Remark.  \end Note that the predicate \ft N \end is defined in 
  the module \it  Standard  \end as: 
  \def 
    pred N 
    N(0)
    N(x+1) <- N(x)
  \end
  \para The proof system uses such predicates (you can define your own ones) for 
  the construction of case rules. Try typing just \it  case  \end and the system 
  gives you the full list of case commands available in the current context. We 
  also recommend to use the pseudo-command \it  open  \end to force opening the 
  definitions of defined functions and predicates. 

rem 
  \para \bf  Example of a definition with discrimination on monadic patterns. 
   \end 

fun F_mona 'Tex_f1_f'
  F_mona(0) = 0
  F_mona(x+1) = 1

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    F_mona(x) = 0 \/ F_mona(x) = 1
  \end
  \para \it  Hint.  \end Use monadic case analysis on \ft x \end. 

thm Prop_f_mona
  F_mona(x) = 0 \/ F_mona(x) = 1

rem 
  \para \bf  Example of a definition with negation discrimination.  \end 

fun/2 F_neg 'Tex_f2_f'
  F_neg(x,y) = 0 <- x = y
  F_neg(x,y) = 1 <- x != y

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    F_neg(x,y) = 0 \/ F_neg(x,y) = 1
  \end
  \para \it  Hint.  \end Use cut rule with the cut formula \ft x = y \end. 

thm Prop_f_neg
  F_neg(x,y) = 0 \/ F_neg(x,y) = 1

rem 
  \para \bf  [CL] Dichotomy case analysis.  \end Syntax: 
  \eq* 
    'case Dich ; <term>,<term>'
  \end
  \para Example(s): 
  \items 
   \item \para \ft Tex_f1_g_x_case Tex_f2_g_x_sc(Dich,Tex0_rho,Tex0_tau) \end 
         \eq* 
           Tex_f3_g_x_nrule(Tex_f0_g_x_nothing,
                            Tex_f2_g_x_branch(Tex_f1_g_x_assum Tex_f2_g_le(Tex0_rho,
                                                                           Tex0_tau),
                                              Tex_f1_g_x_assum Tex_f2_g_gt(Tex0_rho,
                                                                           Tex0_tau)),
                            Tex_f0_g_x_nothing)
         \end
  \end
  \para Note that the predicate \ft Dich \end is defined in the module \it  
  Standard  \end. 

rem 
  \para \bf  Example of a definition with dichotomy discrimination.  \end 

fun/2 F_dich 'Tex_f2_f'
  F_dich(x,y) = 0 <- x <= y
  F_dich(x,y) = 1 <- x > y

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    F_dich(x,y) = 0 \/ F_dich(x,y) = 1
  \end
  \para \it  Hint.  \end Use dichotomy case analysis. 

thm Prop_f_dich
  F_dich(x,y) = 0 \/ F_dich(x,y) = 1

rem 
  \para \bf  [CL] Trichotomy case analysis.  \end Syntax: 
  \eq* 
    'case Trich ; <term>,<term>'
  \end
  \para Note that the predicate \ft Trich \end is defined in the module \it  
  Standard  \end. 

rem 
  \para \bf  Example of a definition with trichotomy discrimination.  \end 

fun/2 F_trich 'Tex_f2_f'
  F_trich(x,y) = 0 <- x < y
  F_trich(x,y) = 1 <- x = y
  F_trich(x,y) = 2 <- x > y

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    F_trich(x,y) = 0 \/ F_trich(x,y) = 1 \/ F_trich(x,y) = 2
  \end
  \para \it  Hint.  \end Use trichotomy case analysis. 

thm Prop_f_trich
  F_trich(x,y) = 0 \/ F_trich(x,y) = 1 \/ F_trich(x,y) = 2

rem 
  \para \bf  Minimum.  \end 

fun/2 Min 'Tex_f2_n_min'
  Min(x,y) = x <- x <= y
  Min(x,y) = y <- x > y

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    Min(x,y) <= x
  \end
  \eq* 
    Min(x,y) <= y
  \end
  \eq* 
    Min(x,y) = x \/ Min(x,y) = y
  \end

thm Spec_min_le1
  Min(x,y) <= x

thm Spec_min_le2
  Min(x,y) <= y

thm Spec_min_eq
  Min(x,y) = x \/ Min(x,y) = y

rem 
  \para \bf  Exercise.  \end \header* fun/2 Max 'Tex_f2_n_max' \end Find an 
  explicit definition of the maximum function \ft Max(x,y) \end satisfying 
  \eq* 
    Max(x,y) >= x
  \end
  \eq* 
    Max(x,y) >= y
  \end
  \eq* 
    Max(x,y) = x \/ Max(x,y) = y
  \end
  \para Prove that the function has the required properties. 

fun/2 Max 'Tex_f2_n_max'
  Max(x,y) = Foo

thm Spec_max_ge1
  Max(x,y) >= x

thm Spec_max_ge2
  Max(x,y) >= y

thm Spec_max_eq
  Max(x,y) = x \/ Max(x,y) = y

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    Min(x,y) <= Max(x,y)
  \end
  \eq* 
    Min(x,y) = Max(x,y) <-> x = y
  \end

thm Min_max_le
  Min(x,y) <= Max(x,y)

thm Min_max_eq
  Min(x,y) = Max(x,y) <-> x = y

rem 
  \para \bf  Exercise.  \end \header* fun/3 Median  \end Find an explicit 
  definition of the function \ft Median(x,y,z) \end satisfying 
  \eq* 
    x <= y & y <= z -> Median(x,y,z) = y
  \end
  \eq* 
    Median(x,y,z) = Median(y,x,z)
  \end
  \eq* 
    Median(x,y,z) = Median(x,z,y)
  \end
  \para Prove that the function has the required properties. 

fun/3 Median 
  Median(x,y,z) = Foo

thm Spec_median_le
  x <= y & y <= z -> Median(x,y,z) = y

thm Spec_median_perm213
  Median(x,y,z) = Median(y,x,z)
proof  proved.

thm Spec_median_perm132
  Median(x,y,z) = Median(x,z,y)
proof  proved.

